//******************************
//oc_modify_generator 0.01
//2007/2/9
//******************************
unit Unit2;
 
interface

uses Classes, SysUtils, StrUtils;

type
        TEntData = record
          Key: String;
          Value: String;
          Section: String;
        end;
        TEntDatas = array[1..256] of TEntData;
        TEntSearchData = record
           ClassNameCount: Integer;
           TargetNameCount: Integer;
           OriginCount: Integer;
           ClassNameIndex: Integer;
           TargetNameIndex: Integer;
           OriginIndex: Integer;
        end;

        TEnt = class(TObject)
        private


          FID: String;

          function GetClassName: String;
          function GetTargetName: String;
          function GetOrigin: String;
          //function GetEntData(Index: Integer): TEntData;

        public
          ClassNameIndex: Integer;
          TargetNameIndex: Integer;
          OriginIndex: Integer;

          EntData: TEntDatas;
          EntDataCount: Integer;
          KeyKey: String;
          KeyValue: String;
          constructor Create;
       // destructor Destroy; override;
          procedure Assign(Source : TEnt);
          function CheckEntData(CKey: String; CValue: String): Integer;
          property ID: String read FID;
          property ClassName: String read GetClassName;
          property TargetName: String read GetTargetName;
          property Origin: String read GetOrigin;

        end;

        Tvmf = class(TObject)
          private
            FEnts: TList;
            FVmf: TStringList;
            procedure InitEnts;
            function GetEntCount: Integer;
            function GetEnt(Index: Integer): TEnt;
            function Section(List: TStringList; SIndex: Integer; SectionName: String; EditEnt: TEnt): Integer;
          public
            constructor Create;
            destructor Destroy; override;
            function LoadVmf(VmfFile: String): Boolean;
            procedure SetKeyIndex;
            function EntSearch(SClassName: String; STargetName: String; SOrigin: String): TEntSearchData;
            function IDtoIndex(SID: String): Integer;
            property EntCount: Integer read GetEntCount;
            property Ents[Index: Integer]: TEnt read GetEnt;
        end;

implementation
//************************************************************
// TEnt
//************************************************************

//RXgN^
constructor TEnt.Create;
begin
        ClassNameIndex := 0;
        TargetNameIndex := 0;
        OriginIndex := 0;
        EntDataCount := 0;
        KeyKey := '';
        KeyValue := '';
        FID := '';
end;

//Rs[
procedure TEnt.Assign(Source : TEnt);
var
  Index: Integer;
begin
  self.ClassNameIndex := Source.ClassNameIndex;
  self.TargetNameIndex := Source.TargetNameIndex;
  self.OriginIndex := Source.OriginIndex;
  self.EntDataCount := Source.EntDataCount;
  self.FID := Source.FID;
  self.KeyKey := Source.KeyKey;
  self.KeyValue := Source.KeyValue;
  for Index := 1 to 256 do
  begin
    self.EntData[Index] := Source.EntData[Index];
  end;
end;

//L[ڃQbg
function TEnt.GetClassName: String;
begin
        Result := '';
        if ClassNameIndex > 0 then
          Result := EntData[ClassNameIndex].Value;
end;
function TEnt.GetTargetName: String;
begin
        Result := '';
        if TargetNameIndex > 0 then
          Result := EntData[TargetNameIndex].Value;
end;

function TEnt.GetOrigin: String;
begin
        Result := '';
        if OriginIndex > 0 then
          Result := EntData[OriginIndex].Value;
end;


//GeBeBf[^̕ύX`FbN
//߂l -1:Y 0:ύX 1ȏ:ύXL
function TEnt.CheckEntData(CKey: String; CValue: String): Integer;
var
  Index: Integer;
begin
  Result := -1;
  for Index := 1 to EntDataCount do
    if (Result <> 0) and (EntData[Index].Key = CKey) then
      if EntData[Index].Value = CValue then
        Result := 0
      else
        Result := Index;
end;


//************************************************************
// TVmf
//************************************************************
//RXgN^[
constructor Tvmf.Create;
begin
        FVmf := TStringList.Create;
        FEnts := TList.Create;
end;

//fXgN^[
destructor Tvmf.Destroy;
begin
        InitEnts;
        FVmf.Free;
end;

//GeBeBXg
procedure Tvmf.InitEnts;
var
        Index: Integer;
begin
         FEnts.Pack;
         for Index := 0 to FEnts.Count-1 do
         begin
           TEnt(FEnts.Items[Index]).free;
           FEnts.Items[Index] := nil;
         end;
         FEnts.Pack;
         FVmf.Clear;
end;

//EntCountvpeB
function Tvmf.GetEntCount: Integer;
begin
        Result := FEnts.count;
end;

//EntvpeB
function Tvmf.GetEnt(Index: Integer): TEnt;
begin
  Result := nil;
  if Index < FEnts.Count then
    Result := TEnt(FEnts.Items[Index]);
end;

//t@Cǂݍ
function TVmf.LoadVmf(VmfFile: String): Boolean;
begin
    Result := False;
    if FileExists(VmfFile) then
    begin
    //t@C݂ꍇ
      //
      InitEnts;

      //VMFt@Cǂݍ
      FVmf.LoadFromFile(VmfFile);

      Section(FVmf, 0, 'root', nil);


      Result := True;
    end;
    
    //GeBeBɃL[
    SetKeyIndex;
end;

//ZNV
function TVmf.Section(List: TStringList; SIndex: Integer; SectionName: String; EditEnt: TEnt): Integer;
var
  Index: Integer;
  VmfData: String;
  NextSectionName: String;
  Position: Integer;
  LocalEntData: String;
begin
  Index := SIndex;
  NextSectionName := '';
  VmfData := Trim(List.Strings[Index]);

  //ZNVentity̏ꍇAGeBeBXgɒǉ
  if (SectionName = 'entity') or (SectionName = 'world') then
  begin
    EditEnt := TEnt.Create;
    FEnts.Add(EditEnt);
  end;

  while (Index + 1 < List.Count) and (VmfData <> '}') do
  begin
    if (SectionName = 'entity') or (SectionName = 'connections') or (SectionName = 'world') then
    begin
    //GeBeBf[^̏ꍇ

          //ʃGeBeBf[^̏
            LocalEntData := VmfData;
            Position := pos('"', LocalEntData);
            if Position > 0 then
            begin
            //̍sɃGeBeBf[^Lꍇ
              EditEnt.EntDataCount := EditEnt.EntDataCount +1;
              
              EditEnt.EntData[EditEnt.EntDataCount].Section := SectionName;
              LocalEntData := RightStr(LocalEntData, Length(LocalEntData) - Position);
              Position := pos('"', LocalEntData);
              EditEnt.EntData[EditEnt.EntDataCount].Key := LeftStr(LocalEntData, Position - 1);
              LocalEntData := RightStr(LocalEntData, Length(LocalEntData) - Position - 2);
              EditEnt.EntData[EditEnt.EntDataCount].Value := LeftStr(LocalEntData, Length(LocalEntData) - 1);

              //ǉf[^L[ꍇ
              if EditEnt.EntData[EditEnt.EntDataCount].Key = 'classname' then
                EditEnt.ClassNameIndex := EditEnt.EntDataCount;
              if EditEnt.EntData[EditEnt.EntDataCount].Key = 'targetname' then
                EditEnt.TargetNameIndex := EditEnt.EntDataCount;
              if EditEnt.EntData[EditEnt.EntDataCount].Key = 'origin' then
                EditEnt.OriginIndex := EditEnt.EntDataCount;

              //L[IDꍇ
              if EditEnt.EntData[EditEnt.EntDataCount].Key = 'id'then
              begin
                EditEnt.FID := EditEnt.EntData[EditEnt.EntDataCount].Value;
                EditEnt.EntDataCount := EditEnt.EntDataCount - 1;
              end;

            end;

    end;

    if pos('{', VmfData) > 0 then
    begin
    //̃ZNV
      Index := Section(List, Index + 1, NextSectionName, EditEnt);
    end;
    NextSectionName := VmfData;

    //indexVmf̏Ȃi߂
    if Index + 1 < List.Count then
      Index := Index + 1;

    VmfData := Trim(List.Strings[Index]);
  end;

  Result := Index;
end;

//GeBeBɃL[
procedure TVmf.SetKeyIndex;
var
  Index: Integer;
  SearchData: TEntSearchData;
begin
  for Index := 0 to EntCount -1 do
  begin
    SearchData := EntSearch(Ents[Index].ClassName,
                            Ents[Index].TargetName,
                            Ents[Index].Origin);
        if SearchData.TargetNameCount = 1 then
        begin
          Ents[Index].KeyKey := 'targetname';
          Ents[Index].KeyValue := Ents[Index].TargetName;
        end
        else
        if SearchData.ClassNameCount = 1 then
        begin
          Ents[Index].KeyKey := 'classname';
          Ents[Index].KeyValue := Ents[Index].ClassName;
        end
        else
        if SearchData.OriginCount = 1 then
        begin
          Ents[Index].KeyKey := 'origin';
          Ents[Index].KeyValue := Ents[Index].Origin;
        end
        else
        begin
          Ents[Index].KeyKey := '';
          Ents[Index].KeyValue := '';
        end;
  end;
end;

//IDIndext
function TVmf.IDtoIndex(SID: String): Integer;
var
  Index: Integer;
begin
  Result := -1;
  for Index := 0 to FEnts.Count -1 do
  begin
    if TEnt(FEnts.items[Index]).FID = SID then
      Result := Index;
  end;
end;

//L[̐ƃCfbNX
function TVmf.EntSearch(SClassName: String; STargetName: String; SOrigin: String): TEntSearchData;
var
  Index: Integer;
begin
  Result.ClassNameCount := 0;
  Result.TargetNameCount := 0;
  Result.OriginCount := 0;
  Result.ClassNameIndex := -1;
  Result.TargetNameIndex := -1;
  Result.OriginIndex := -1;

  for Index := 0 to FEnts.Count -1 do
  begin
    if (SClassName <> '') and (TEnt(FEnts.items[Index]).ClassName = SClassName) then
    begin
      Result.ClassNameCount := Result.ClassNameCount +1;
      Result.ClassNameIndex := Index;
    end;

    if (STargetName <> '') and (TEnt(FEnts.items[Index]).TargetName = STargetName) then
    begin
      Result.TargetNameCount := Result.TargetNameCount +1;
      Result.TargetNameIndex := Index;
    end;

    if (SOrigin <> '') and (TEnt(FEnts.items[Index]).Origin = SOrigin) then
    begin
      Result.OriginCount := Result.OriginCount +1;
      Result.OriginIndex := Index;
    end;
  end;
end;


end.
